'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createStore = exports.app = exports.subscribe = exports.provide = exports.action = undefined;
exports.createAlfa = createAlfa;

var _app = require('./app');

Object.defineProperty(exports, 'app', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_app).default;
  }
});

var _store = require('./store');

Object.defineProperty(exports, 'createStore', {
  enumerable: true,
  get: function get() {
    return _interopRequireDefault(_store).default;
  }
});

var _store2 = _interopRequireDefault(_store);

var _action = require('./action');

var _action2 = _interopRequireDefault(_action);

var _injection = require('./injection');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Export function for creating a new alfa instance.
 * @return {Function}
 */
function createAlfa() {
  var alfa = {};
  var store = (0, _store2.default)();

  alfa.action = (0, _action2.default)(store);
  alfa.provide = (0, _injection.createProvide)(store);
  alfa.subscribe = (0, _injection.createSubscribe)(store);

  return alfa;
}

/**
 * Default global instance of alfa.
 * @type {Function}
 */
var alfa = createAlfa();

/**
 * Export other toplevel APIs.
 */
exports.default = alfa;
var action = exports.action = alfa.action;
var provide = exports.provide = alfa.provide;
var subscribe = exports.subscribe = alfa.subscribe;